package com.sun.xml.internal.bind.v2.runtime.reflect;

import javax.xml.stream.XMLStreamException;
import java.io.IOException;
import com.sun.xml.internal.bind.v2.runtime.Name;
import com.sun.xml.internal.bind.v2.runtime.XMLSerializer;
import org.xml.sax.SAXException;
import com.sun.xml.internal.bind.api.AccessorException;

public abstract class DefaultTransducedAccessor<T> extends TransducedAccessor<T>
{
    public DefaultTransducedAccessor() {
    }
    
    @Override
    public abstract String print(T p0) throws AccessorException, SAXException;
    
    @Override
    public void writeLeafElement(XMLSerializer w, Name tagName, T o, String fieldName) throws SAXException, AccessorException, IOException, XMLStreamException {
        w.leafElement(tagName, this.print(o), fieldName);
    }
    
    @Override
    public void writeText(XMLSerializer w, T o, String fieldName) throws AccessorException, SAXException, IOException, XMLStreamException {
        w.text(this.print(o), fieldName);
    }
}
